/*	WmDOT v.7-GS, r.148 [2011-12-03],
 *		adapted from WmDOT (the AI) v.6, r.118 [2011-04-28]
 *	Copyright  2011 by W. Minchin. For more info,
 *		please visit http://openttd-noai-wmdot.googlecode.com/
 */

import("Queue.Binary_Heap","Binary_Heap",1);
import("util.MinchinWeb","MinchinWeb",2);
 
 class WmDOT_GS_Test extends GSController 
{
	//	SETTINGS
	WmDOTv = 7;
	/*	Version number of GS
	 */	
	WmDOTr = 142;
	/*	Reversion number of GS
	 */
  
	function Start();
}


function WmDOT_GS_Test::Start()
{
	GSLog.Info("Welcome to WmDOT-Test, GameScript Edition, version " + WmDOTv + ", revision " + WmDOTr + " by W. Minchin.");
	GSLog.Info("Copyright  2011 by W. Minchin. For more info, please visit http://www.tt-forums.net/viewtopic.php?f=65&t=53698")
	GSLog.Info(" ");

	GSLog.Info("Loading Libraries...");	
	
	local heap = Binary_Heap();
	for (local i=0; i<5; i++) {
		local weight = GSBase.Rand();
		GSLog.Info("Enter " + i + " at " + weight);
		heap.Insert(i,weight);
	}
	
	while (heap.Count() > 0){
		GSLog.Info("Exit " + heap.Pop() );
	}
	
	
	
	GSRoad.SetCurrentRoadType(GSRoad.ROADTYPE_ROAD);
		//	Build normal road (no tram tracks)
	
	local now = GSDate.GetSystemTime();

//	Sleep(1);
//	local comp = GSCompanyMode(0);
	local exec = GSExecMode();
	GSLog.Info("Company " + GSCompany.ResolveCompanyID(0));
//	GSCompany.SetLoanAmount(GSCompany.GetLoanInterval());
//	GSLog.Info("Loan set to zero");

//	Crash();
	local x = 50;
	local y = 40;
	GSViewport.ScrollTo(GSMap.GetTileIndex(x,y));
	GSRoad.BuildRoadDepot(GSMap.GetTileIndex(x,y), GSMap.GetTileIndex(x,y+1));
	for (local i=0; i<20; i++){
		for (local j=0; j<20; j++){
			GSRoad.BuildRoad(GSMap.GetTileIndex(x-1+i,y-1+j), GSMap.GetTileIndex(x-1+i,y+j));
		}
	}
	
	local i = 5
	for (local j=0; j<20; j++){
		GSSign.BuildSign(GSMap.GetTileIndex(x-1+i,y-1+j),"Remove Here");
		GSRoad.RemoveRoadFull(GSMap.GetTileIndex(x-1+i,y-1+j), GSMap.GetTileIndex(x-1+i,y+j));
	}
	
	x = 95;
	y = 65;
	GSViewport.ScrollTo(GSMap.GetTileIndex(x+10,y+10));
	local start = GSMap.GetTileIndex(x-2,y);
	local end = GSMap.GetTileIndex(x-2,y+6);
	
//	GSBridge.BuildBridge(GSVehicle.VT_ROAD,0,GSMap.GetTileIndex(x,y),GSMap.GetTileIndex(x+4,y));
	GSLog.Info("Build Bridge");
	GSLog.Info("Is Bridge Tile: " + GSBridge.IsBridgeTile(start));
	
	exec = null;
	exec = GSTestMode();
	local BridgeList = GSBridgeList_Length(GSMap.DistanceManhattan(start, end + 1));
	BridgeList.Valuate(GSBridge.GetMaxSpeed);
	BridgeList.Sort(GSList.SORT_BY_VALUE, false);
	if (!GSBridge.BuildBridge(GSVehicle.VT_ROAD, BridgeList.Begin(), start, end)) {
	//	At this point, an error has occured while building the bridge.
	//	Fail the pathfiner
	//	return null;
		GSLog.Warning("MetaLib.RoadPathfinder.GetBuildCost can't build a bridge from " + GSMap.GetTileX(start) + "," + GSMap.GetTileY(start) + " to " + GSMap.GetTileX(end) + "," + GSMap.GetTileY(end) + "!!" );
	}
	GSLog.Info("Is Bridge Tile: " + GSBridge.IsBridgeTile(start));

	exec = null;
	exec = GSExecMode();
	start = GSMap.GetTileIndex(x-3,y);
	end = GSMap.GetTileIndex(x-3,y-6);	
	if (!GSBridge.BuildBridge(GSVehicle.VT_ROAD, BridgeList.Begin(), start, end)) {
	//	At this point, an error has occured while building the bridge.
	//	Fail the pathfiner
	//	return null;
		GSLog.Warning("MetaLib.RoadPathfinder.GetBuildCost can't build a bridge from " + GSMap.GetTileX(start) + "," + GSMap.GetTileY(start) + " to " + GSMap.GetTileX(end) + "," + GSMap.GetTileY(end) + "!!" );
	}
	GSLog.Info("Is Bridge Tile: " + GSBridge.IsBridgeTile(start));
	
	local pathfinder = MinchinWeb.RoadPathfinder();
	local start = GSMap.GetTileIndex(x,y);
	local end = GSMap.GetTileIndex(x+10,y);
	GSSign.BuildSign(start,"Start");
	GSSign.BuildSign(end,"End");
	pathfinder.InitializePath([start],[end]);
	local path = false;
	local cycles = 0;
	local TempCompany = GSCompanyMode(0);
	while (path == false) {
		path = pathfinder.FindPath(1);
		cycles++;	
	}
	GSLog.Info(cycles + " cycles...");
	TempCompany = null;
	pathfinder.BuildPath();	
	
//	GSRoad.BuildRoad(GSMap.GetTileIndex(x-1,y-1), GSMap.GetTileIndex(x-1,y));
	GSLog.Info("Road Building Complete");
	Sleep(1);
	while (true) {
		now = GSDate.GetSystemTime();
		while (GSDate.GetSystemTime() - now < 10) {
			this.Sleep(30);
		}
	}
}